SystemOrganization addCategory: #SWA014!

Object subclass: #SWA014Upgrade
	instanceVariableNames: 'upgradeOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

SWA014Upgrade subclass: #SWA014TrapUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014TrapUpgrade methodsFor: 'starting up' stamp: 'MV 1/3/2017 10:11'!
activateUpgrade
	self
		spawnTrap;
		exchangeAllCollisionObjects;
		yourself.! !

!SWA014TrapUpgrade methodsFor: 'exchange' stamp: 'MV 1/3/2017 10:11'!
exchangeAllCollisionObjects
	|listOfLivingThings|
	listOfLivingThings := self upgradeOwner swaworld listOfEnemies copy.
	listOfLivingThings add: self upgradeOwner swaworld swaplayer.
	
	listOfLivingThings do: [:aLivingThing|
		self exchangeCollisionObjectFor: aLivingThing].! !

!SWA014TrapUpgrade methodsFor: 'exchange' stamp: 'MV 1/3/2017 02:52'!
exchangeCollisionObject
	|collisionObject|
	collisionObject := SWA014TrapCollisionObject new.
	collisionObject objectOwner: self upgradeOwner.
	self upgradeOwner collisionObject: collisionObject.! !

!SWA014TrapUpgrade methodsFor: 'exchange' stamp: 'MV 1/3/2017 10:42'!
exchangeCollisionObjectFor: aLivingThing
	|collisionObject|
	collisionObject := SWA014TrapCollisionObject newWithOwner: aLivingThing.
	aLivingThing collisionObject: collisionObject.! !

!SWA014TrapUpgrade methodsFor: 'world manipulation' stamp: 'MV 1/3/2017 02:58'!
spawnTrap
	|aTrap|
	aTrap := SWA014Trap new openInWorld.
	aTrap center: self upgradeOwner center - (self upgradeOwner direction * 100).
	self upgradeOwner swaworld listOfTraps add: aTrap.
	self upgradeOwner swaworld addMorph: aTrap.
! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'MV 1/3/2017 02:48'!
activateUpgrade
	"The different Upgrades should overwrite this. This method gets called, when the player wants to use an Upgrade."
	self flag: 'TODISCUSS: Mit der einen Zeile Code wird der Kommentar, glaube ich, überflüssig ... Tim'.
	self flag: 'TODISCUSS: Diese Methode soll trotzdem aufgerufen werden können, ohne das ein Fehler geschmissen wird. Deswegen wäre ich gegen subclassRespansibility. Die UpgradeKlasse ist quasi ein Nullobjekt und dient gleichzeitig als vorlage für andere Upgrades'.
	! !

!SWA014Upgrade methodsFor: 'accessors' stamp: 'MV 12/22/2016 14:58'!
upgradeOwner
	^upgradeOwner.! !

!SWA014Upgrade methodsFor: 'accessors' stamp: 'MV 12/22/2016 14:58'!
upgradeOwner: aLivingThing
	upgradeOwner := aLivingThing.! !

CircleMorph subclass: #SWA014Food
	instanceVariableNames: 'bodysize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Food class methodsFor: 'as yet unclassified' stamp: 'Tc 12/31/2016 14:49'!
newWithSize: aSize		
	^self new
		bodysize: aSize;
		extent: aSize asPoint;
		color: Color yellow;
		yourself.
		! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize 
	^bodysize.! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize: aSize
	bodysize := aSize.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed id direction world currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed realCenter upgradeList collisionObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:39'!
bigNumber
	^SmallInteger maxVal.! !

!SWA014Enemy methodsFor: 'movement' stamp: 'MV 12/20/2016 13:31'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target realCenter.
	
	target bodysize >= self bodysize
	ifTrue: [	self direction: 0.0 asPoint - self direction].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'MV 12/22/2016 11:32'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance|
	
	smallestDistance := self bigNumber.
	nearestEnemyobject := self.
	
	allEnemies := Set new.
	allEnemies := self swaworld listOfEnemies copy.
	allEnemies add: self swaworld swaplayer.
	
	allEnemies do: [:enemy| 
		currentDistance := self distanceTo: (enemy realCenter).
		currentDistance  < smallestDistance ifTrue: [
			smallestDistance := currentDistance.
			nearestEnemyobject := enemy]]
	without: self.

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'Tc 12/31/2016 15:33'!
step
	self flag: 'Bitte kommentieren, wieso hier Code auskommentiert ist, ob er je wieder verwendet wird bzw. was mit ihm geschehen wird'.
	"self currentStep > self stepNumber
		ifTrue: ["
			self 
				calculateMovement: self nearestEnemy;
				moveAutomatically;
				currentStep: 0;
				yourself"] 
		ifFalse: [self currentStep: self currentStep + 1]".
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 12/16/2016 12:09'!
bodysize: x
	x < (self maxAllowedSize)
		ifTrue: [
			x > (self minAllowedSize) 
				ifTrue: [	bodysize := x]
				ifFalse: [bodysize := self minAllowedSize]]
		ifFalse: [bodysize := self maxAllowedSize].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 13:23'!
calculateMovement: target
	|directionVector deltaX deltaY distance|
		
	deltaX := target x - self realCenter x.
	deltaY := target y - self realCenter y.
	
	distance := ((deltaX raisedTo: 2) +
	 			(deltaY raisedTo: 2)) sqrt.
	distance = 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	
	directionVector := (deltaX/distance)@(deltaY/distance).
	
	self direction: directionVector.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/2/2017 23:07'!
checkForCollisionsWithFood
	|radius|
	self flag: 'Diese Methode wird zur Zeit nicht verwendet'.
	self flag: 'TODISCUSS: If we need radius at least one more time, it should be a method'.
	radius := (self bodysize/2) raisedTo: 2.

	self swaworld listOfFood do: [:eatable|
		((self distanceTo: (eatable center - self swaworld realCenter + ((self swaworld width / 2)@(self swaworld height / 2)))) < radius) ifTrue: [
			self eat: eatable]].! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/10/2016 14:04'!
checkForOverlapWith: enemy
	^(self bottom > enemy top and: 
	    self top < enemy bottom and:
	    self left < enemy right and:
	    self right > enemy left).
! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 15:21'!
collisionObject
	^collisionObject.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 15:21'!
collisionObject: anObject
	collisionObject := anObject.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 12/20/2016 13:20'!
distanceTo: enemy
	^((enemy x - self realCenter x) raisedTo: 2) +
	 ((enemy y - self realCenter y) raisedTo: 2). "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'PG 1/6/2017 12:17'!
eat: prey
	self bodysize: 2* (((self bodysize / 2) raisedTo: 2) + ((prey bodysize / 2) raisedTo: 2)) sqrt.

	self swaworld listOfEnemies: (self swaworld listOfEnemies reject: [:enemy| enemy == prey]).
	self swaworld listOfFood: (self swaworld listOfFood reject: [:eatable| eatable == prey]).
	(prey ~~ self swaworld swaplayer) 
		ifTrue: [	prey delete.
				self swaworld game spawnEnemy. ]
		ifFalse: [self swaworld game gameOver].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'MV 1/3/2017 02:32'!
initialize
	super initialize.
	
	self 
		maxAllowedSize: 1000;
		maxAllowedSpeed: 1000;
		minAllowedSize: 10;
		minAllowedSpeed: 0;
		currentStep: 0;
		speed: 2.0;
		direction: 0.0 asPoint;
		borderWidth: 2; "these initial values don't change at runtime"
		upgradeList: Dictionary new;
		collisionObject: SWA014StandartCollisionObject new;
		yourself.
		
	self collisionObject objectOwner: self.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSize
	^maxAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize: aNumber
	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSpeed
	^maxAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:12'!
maxAllowedSpeed: aNumber
	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
minAllowedSize
	^minAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:33'!
minAllowedSize: aNumber
	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:36'!
minAllowedSpeed
	^minAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:13'!
minAllowedSpeed: aNumber
	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/3/2017 00:33'!
moveAutomatically
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:29'!
realCenter
	^realCenter.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:30'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 16:15'!
refreshCenter
	self center: self swaworld realCenter - ((self swaworld width / 2)@(self swaworld height / 2)) + self realCenter.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/16/2016 15:48'!
speed: x
	x < self maxAllowedSpeed 
		ifTrue: [
			x> (self minAllowedSpeed) 
			ifTrue: [speed := x]
			ifFalse: [speed := self minAllowedSpeed]]
		ifFalse: [speed := self maxAllowedSpeed].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 1/2/2017 23:25'!
step
	self	collisionObject checkForCollisions.
	
	self	refreshSize;
		"refreshCenter;"
		yourself.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'Tc 12/31/2016 15:34'!
stepNumber
	"This is used to keep the stepTime up to date"
	self flag: 'Zur Zeit nicht verwendeet und auch verhaltenstechnisch als (leicht) fehlerhaft anzusehen'.
	
	^self speed ~= 0
	   	ifTrue: [	10 * self bodysize / self speed]
		ifFalse: [SmallInteger maxVal. "Stepping very slow"].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/21/2016 19:03'!
stepTime
	^1.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/18/2016 13:12'!
swaworld: x
	world := x.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:38'!
upgradeList
	^upgradeList.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:37'!
upgradeList: aList
	upgradeList := aList.! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'initialization' stamp: 'MV 1/3/2017 01:07'!
initialize
	super initialize.
	self speed: 3.0.! !

!SWA014Player methodsFor: 'movement' stamp: 'MV 1/3/2017 00:34'!
moveAutomatically
	self swaworld realCenter: self swaworld realCenter - (self speed * self direction).
	self swaworld refreshCenter.
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014Player methodsFor: 'movement' stamp: 'Tc 12/31/2016 15:38'!
movementConstant
	^3! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'Tc 12/31/2016 15:38'!
step
	super step.
	
	self 
		calculateMovement: World activeHand center - (self swaworld realCenter) + ((self swaworld width / 2)@(self swaworld height / 2));
		moveAutomatically;
		yourself.! !

CircleMorph subclass: #SWA014Trap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Trap methodsFor: 'initialization' stamp: 'MV 1/3/2017 02:51'!
initialize
	super initialize.
	self 
		color: Color blue;
		extent: 15 asPoint;
		yourself.! !

Morph subclass: #SWA014Game
	instanceVariableNames: 'world maxSize numberOfEnemies foodSize amountOfFood'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/3/2017 13:13'!
open
	self flag: 'TODO: Here is some code commented out: Decide what to do with it later'.
	^self new spawnPlayer; "spawnEnemy;" "spawnFood;" openInWorld; yourself.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood
	^amountOfFood.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood: anAmount
	amountOfFood := anAmount.! !

!SWA014Game methodsFor: 'upgrade managment' stamp: 'MV 1/3/2017 02:35'!
enableTrapFor: aLivingThing
	|anUpgrade anAssociation|
	anUpgrade := SWA014TrapUpgrade new.
	anUpgrade upgradeOwner: aLivingThing.
	anAssociation := Association new key: #Trap value: anUpgrade.
	aLivingThing upgradeList add: anAssociation.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize
	^foodSize.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize: aSize
	foodSize := aSize.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 12/16/2016 11:35'!
gameOver
	self delete.! !

!SWA014Game methodsFor: 'initialization' stamp: 'PG 1/6/2017 14:18'!
initialize
	super initialize.

	self 
		extent: ActiveWorld extent;
		clipSubmorphs: true;
		swaworld: SWA014World new;
		addMorph: self swaworld;
		maxSize: 75;
		foodSize: 10;
		numberOfEnemies:50;
		amountOfFood: 1000; "initial values"
		yourself.
		
		1 to: numberOfEnemies do:[:x|self spawnEnemy ]. 
		
	self swaworld game: self.
	self swaworld center: self center.
	self swaworld realCenter: self center.
! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
maxSize
	^maxSize.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:50'!
maxSize: aSize
	maxSize := aSize.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:03'!
numberOfEnemies
	^numberOfEnemies.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:25'!
numberOfEnemies: aNumber
	numberOfEnemies := aNumber.! !

!SWA014Game methodsFor: 'spawning' stamp: 'PG 1/6/2017 12:11'!
spawnEnemy
	|enemy random r1 r2 r3|
	
	enemy := SWA014Enemy new.
	random := Random new.
	r1 := random nextInt: self swaworld width.
	r2 := random nextInt: self swaworld height.
	r3 := random nextInt: (self maxSize).
	enemy realCenter: r1@r2.
	enemy bodysize: r3.	
	enemy swaworld: self swaworld.
	enemy refreshCenter.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/20/2016 16:17'!
spawnFood
	|eatable random r1 r2|

	self flag: 'Diese Methode ist extrem ähnlich zu spawnEnemy. Wie sollten das irgendwie zusammenfassen'.
		
	1 to: (self amountOfFood)  do: [:x|	
		eatable := SWA014Food newWithSize: self foodSize.
		random := Random new.
		r1 := random nextInt: self swaworld width.
		r2 := random nextInt: self swaworld height.
		eatable center: ((r1 + self swaworld left) @ (r2 + self swaworld top)).
		self swaworld listOfFood add: eatable.
		self swaworld addMorph: eatable].! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/20/2016 15:00'!
"An importent disigndicision is, that the player isn't added to the world but to the game instead. This removes redundant code to hold the player in the center of the world, stops strange things happening cause of rounding errors and there is no more need for workarounds, when colliding with the worldbouns."

spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new.
	newPlayer color: Color red.
	newPlayer bodysize: 60.
	newPlayer realCenter: (self swaworld width / 2)@(self swaworld height / 2).
	newPlayer center: self center.
	newPlayer swaworld: self swaworld.		
	self swaworld swaplayer: newPlayer.
	self swaworld addMorph: newPlayer.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'override' stamp: 'PG 1/6/2017 12:17'!
step
	|missingEnemies|
	self flag:'In Methode auslagern!!'.
	self flag:'Wird diese Methode überhaupt noch gebraucht? Tim'.
	"self swaworld swaplayer realCenter: self center.
	self swaworld swaplayer center: self center."
	
	"missingEnemies := self numberOfEnemies - (self swaworld listOfEnemies count: [:each| true]).
	1 to: missingEnemies do: [:x|
		self spawnEnemy]."! !

!SWA014Game methodsFor: 'override' stamp: 'MV 1/3/2017 12:03'!
stepTime
	^10.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'Tc 12/4/2016 21:26'!
swaworld: aWorld
	world := aWorld.! !

Morph subclass: #SWA014StandartCollisionObject
	instanceVariableNames: 'objectOwner steppingEnabled iteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StandartCollisionObject class methodsFor: 'initialization' stamp: 'MV 1/3/2017 11:35'!
newWithOwner: aLivingThing
	|collisionObject|
	collisionObject := self new.
	
	collisionObject
		openInWorld;
		hide;
		objectOwner: aLivingThing;
		stopStepping;
		steppingEnabled: false;
		yourself.
	aLivingThing addMorph: collisionObject.
	^collisionObject.! !

!SWA014StandartCollisionObject methodsFor: 'collision handling' stamp: 'MV 1/2/2017 23:32'!
checkForCollisions
	self checkForCollisionsWithLivingThings.! !

!SWA014StandartCollisionObject methodsFor: 'collision handling' stamp: 'MV 1/3/2017 10:05'!
checkForCollisionsWithLivingThings
	|radius listOfLivingThings|
	self flag: 'Eventuell sollten Foodcollisions von normalen getrennt werden. Diese Methode ist zu lang'.
	
	radius := self objectOwner bodysize/2.
	radius := radius raisedTo: 2.
	listOfLivingThings := self objectOwner swaworld listOfEnemies copy.
	listOfLivingThings add: self objectOwner swaworld swaplayer.
	
	listOfLivingThings do: [:enemy|
		(enemy ~~ self objectOwner) ifTrue: [
			((self objectOwner == self objectOwner swaworld swaplayer) and: (self objectOwner checkForOverlapWith: enemy)) ifTrue: [
				(enemy bodysize < self objectOwner bodysize)
				ifTrue: [enemy goBehind] 
				ifFalse: [enemy comeToFront]].
			
			(enemy bodysize < self objectOwner bodysize) ifTrue: [					
				((self objectOwner distanceTo: enemy realCenter) < radius) ifTrue: [
					self objectOwner eat: enemy]]]].

	self objectOwner swaworld listOfFood do: [:eatable|
		((self objectOwner distanceTo: (eatable center 
						   - self objectOwner swaworld realCenter 
						   + ((self objectOwner swaworld width / 2)@(self objectOwner swaworld height / 2))))
						 < radius) ifTrue: [
			self objectOwner eat: eatable]].! !

!SWA014StandartCollisionObject methodsFor: 'accessing' stamp: 'MV 1/3/2017 11:38'!
iteration
	^ iteration.! !

!SWA014StandartCollisionObject methodsFor: 'accessing' stamp: 'MV 1/3/2017 11:38'!
iteration: anObject
	iteration := anObject.! !

!SWA014StandartCollisionObject methodsFor: 'accessing' stamp: 'MV 12/22/2016 15:15'!
objectOwner
	^objectOwner.! !

!SWA014StandartCollisionObject methodsFor: 'accessing' stamp: 'MV 12/22/2016 15:15'!
objectOwner: aLivingThing
	objectOwner := aLivingThing.! !

!SWA014StandartCollisionObject methodsFor: 'accessing' stamp: 'MV 1/3/2017 11:34'!
steppingEnabled
	^ steppingEnabled.! !

!SWA014StandartCollisionObject methodsFor: 'accessing' stamp: 'MV 1/3/2017 11:34'!
steppingEnabled: anObject
	steppingEnabled := anObject.! !

SWA014StandartCollisionObject subclass: #SWA014TrapCollisionObject
	instanceVariableNames: 'ownerSpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014TrapCollisionObject methodsFor: 'collision handling' stamp: 'MV 1/2/2017 23:30'!
checkForCollisions
	self 
		checkForCollisionsWithLivingThings;
		checkForCollisionsWithTraps;
		yourself.! !

!SWA014TrapCollisionObject methodsFor: 'collision handling' stamp: 'MV 1/3/2017 02:54'!
checkForCollisionsWithTraps
	|radius swaworld|
	self flag: 'Diese Methode wird zur Zeit nicht verwendet'.
	self flag: 'TODISCUSS: If we need radius at least one more time, it should be a method. EDIT: We need it one more time!!'.
	radius := (self objectOwner bodysize/2) raisedTo: 2.
	swaworld := self objectOwner swaworld.

	swaworld listOfTraps do: [:aTrap|
		((self objectOwner distanceTo: (aTrap center - swaworld realCenter + ((swaworld width / 2)@(swaworld height / 2)))) < radius) ifTrue: [
			self collideWithTrap: aTrap]].! !

!SWA014TrapCollisionObject methodsFor: 'collision handling' stamp: 'MV 1/3/2017 11:39'!
collideWithTrap: triggerdTrap
	self inflictAilments.
	self arrangeToStartStepping.
	self iteration: 0.
	self steppingEnabled: true.
	
	self objectOwner swaworld listOfTraps: (self objectOwner swaworld listOfTraps reject: [:aTrap| aTrap == triggerdTrap]).
	triggerdTrap delete.! !

!SWA014TrapCollisionObject methodsFor: 'ailments' stamp: 'MV 1/3/2017 00:52'!
inflictAilments
	self ownerSpeed: self objectOwner speed.
	self objectOwner speed: 0.
	self objectOwner bodysize: self objectOwner bodysize / 2.! !

!SWA014TrapCollisionObject methodsFor: 'initialization' stamp: 'MV 1/3/2017 11:21'!
initialize
	super initialize.
"	self stopStepping;
		ownerSpeed: 0;
		yourself."! !

!SWA014TrapCollisionObject methodsFor: 'accessing' stamp: 'MV 1/3/2017 00:51'!
ownerSpeed
	^ ownerSpeed.! !

!SWA014TrapCollisionObject methodsFor: 'accessing' stamp: 'MV 1/3/2017 00:51'!
ownerSpeed: aSpeed
	ownerSpeed := aSpeed.! !

!SWA014TrapCollisionObject methodsFor: 'ailments' stamp: 'MV 1/3/2017 10:36'!
resetStatusAilments
	self objectOwner speed: self ownerSpeed.
	self objectOwner bodysize: (self objectOwner bodysize * 2).! !

!SWA014TrapCollisionObject methodsFor: 'stepping' stamp: 'MV 1/3/2017 11:42'!
step
	self steppingEnabled ifTrue: [
		self iteration = 1 
			ifTrue: [	
					self resetStatusAilments.
					self stopStepping.
					self steppingEnabled: false.
					self iteration: 0]
			ifFalse: [self iteration: 1]].
	! !

!SWA014TrapCollisionObject methodsFor: 'stepping' stamp: 'MV 1/3/2017 11:11'!
stepTime
 ^5000.! !

ImageMorph subclass: #SWA014Menu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Menu class methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:32'!
open
	^SWA014Menu new openInWorld.! !

!SWA014Menu methodsFor: 'initialization' stamp: 'MV 1/3/2017 01:25'!
initialize 
	super initialize.
	
	self 
		image: (Form fromFileNamed: 'Chrysanthemum.jpg'); "Be sure, that the picture is in the resource folder with the correct name"
		addMorph:  SWA014StartButton new;
		addMorph: SWA014EndButton new;
		yourself.! !

ImageMorph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies listOfFood listOfDeadThings swaplayer game realCenter listOfTraps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'collisionHandling' stamp: 'MV 12/22/2016 12:06'!
checkForBorderCollisions
	|enemyListWithPlayer|
	
	enemyListWithPlayer:= listOfEnemies copy.
	enemyListWithPlayer add: self swaplayer.
	
	enemyListWithPlayer do: [:enemy | 
		enemy bounds right > self bounds right ifTrue:	[
			enemy == self swaplayer ifTrue: [
				self realCenter: (enemy bounds right - (self width / 2))@(self realCenter y).
				self refreshCenter]. 
			enemy realCenter: (self width - (enemy bodysize / 2))@(enemy realCenter y).
			enemy refreshCenter].
	
		enemy bounds left < self bounds left ifTrue: [
			enemy == self swaplayer ifTrue: [
				self realCenter: (enemy bounds left + (self width / 2))@(self realCenter y).
				self refreshCenter]. 
			enemy realCenter: (enemy bodysize / 2)@(enemy realCenter y).
			enemy refreshCenter].
	
		enemy bounds top < self bounds top ifTrue: [
			enemy == self swaplayer ifTrue: [
				self realCenter: (self realCenter x)@(enemy bounds top + (self height / 2)).
				self refreshCenter]. 
			enemy realCenter: (enemy realCenter x)@(enemy bodysize / 2).
			enemy refreshCenter].
			
		enemy bounds bottom > self bounds bottom ifTrue: [
			enemy == self swaplayer ifTrue: [
				self realCenter: (self realCenter x)@(enemy bounds bottom - (self height / 2)).
				self refreshCenter]. 
			enemy realCenter: (enemy realCenter x)@(self height - (enemy bodysize / 2)).
			enemy refreshCenter]].
! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'event handling' stamp: 'MV 1/3/2017 02:44'!
handleKeystroke: anEvent
	|keyValue|
	keyValue := anEvent keyValue.
	
	keyValue = 49 ifTrue: [ "Taste: 1"
		(self swaplayer upgradeList at: #Trap ifAbsent: [SWA014Upgrade new]) activateUpgrade].! !

!SWA014World methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:49'!
handlesMouseOver: anEvent
	^true.! !

!SWA014World methodsFor: 'initialization' stamp: 'MV 1/3/2017 01:26'!
initialize
	super initialize.
		
	self 
		image: (Form fromFileNamed: 'Chrysanthemum.jpg');"Be sure, that the picture is in the resource folder with that name"
		listOfEnemies: Set new;
		listOfFood: Set new;
		listOfTraps: Set new;
		swaplayer: nil;
		worldSize: 3000;
		extent: self worldSize asPoint;	
		color: Color transparent;
		clipSubmorphs: true;
		center: 0 asPoint;
		realCenter: 0.0 asPoint;
		yourself.
	
	
! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'MV 12/22/2016 14:38'!
listOfEnemies: aList
	listOfEnemies := aList! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:39'!
listOfFood
	^ listOfFood.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/2/2017 22:57'!
listOfFood: aList
	listOfFood := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/3/2017 00:07'!
listOfTraps
	^ listOfTraps.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/3/2017 00:07'!
listOfTraps: aList
	listOfTraps := aList.! !

!SWA014World methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:50'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self.! !

!SWA014World methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:51'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter
	^realCenter.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014World methodsFor: 'movement' stamp: 'Tc 12/31/2016 15:48'!
refreshCenter
	self flag: 'Dieser Code ist zur Zeit tot, siehe step'.
	self center: self realCenter.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'MV 12/22/2016 11:00'!
step
	self 
		checkForBorderCollisions;
		"refreshCenter;"
		yourself.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'Tc 12/2/2016 16:02'!
stepTime
	^100! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer
	^swaplayer.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer: x
	swaplayer := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:31'!
worldSize
	^worldSize! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:32'!
worldSize: anObject
	worldSize := anObject! !

SimpleButtonMorph subclass: #SWA014EndButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EndButton methodsFor: 'as yet unclassified' stamp: 'Tc 12/31/2016 14:48'!
initialize 
	super initialize.

	self 
		label: 'End Game';
		color: Color yellow;
		center: (World width /2)@((13/25) * World height); "The position is set full out of our preferences"
		yourself.! !

!SWA014EndButton methodsFor: 'as yet unclassified' stamp: 'Tc 12/31/2016 14:46'!
mouseDown: event
	owner delete.! !

SimpleButtonMorph subclass: #SWA014StartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StartButton methodsFor: 'as yet unclassified' stamp: 'MV 1/2/2017 23:18'!
initialize 
	super initialize.

	self 
		label: 'Start Game';
		color: Color blue;
		center: (World width /2)@((12/25) * World height);
		yourself.! !

!SWA014StartButton methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:33'!
mouseDown: evt
	SWA014Game open.! !
